#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <whaminit.h>

#define number_of_objs 10

DIALOG choice[] =
{
   { d_clear_proc,      0,      0,      0,    0,  255,  253,    0,    0,       0,    0,    NULL },
   { d_check_proc,      10,    10,    180,   10,  255,  253,    0,    0,       0,    0,    "Buffered" },
   { d_check_proc,      10,    20,    180,   10,  255,  253,    0,    0,       0,    0,    "Use Boxlist Algorithm" },
   { d_check_proc,      10,    30,    180,   10,  255,  253,    0,    D_SELECTED,       0,    0,    "Full Remove" },
   { d_radio_proc,      10,    50,    180,   10,  255,  253,    0,    D_SELECTED,       1,    0,    "No Shadow" },
   { d_radio_proc,      10,    60,    180,   10,  255,  253,    0,    0,       1,    0,    "Slow Shadow" },
   { d_radio_proc,      10,    70,    180,   10,  255,  253,    0,    0,       1,    0,    "Fast Shadow" },
   { d_radio_proc,      10,    80,    180,   10,  255,  253,    0,    0,       1,    0,    "Simple Shadow" },
   { d_radio_proc,      10,    90,    180,   10,  255,  253,    0,    0,       1,    0,    "Pattern Shadow" },
   { d_radio_proc,      10,   110,    180,   10,  255,  253,    0,    D_SELECTED,       2,    0,    "FrameWin" },
   { d_radio_proc,      10,   120,    180,   10,  255,  253,    0,    0,       2,    0,    "BorderWin" },
   { d_radio_proc,      10,   130,    180,   10,  255,  253,    0,    0,       2,    0,    "BillWin" },
   { d_button_proc,     220,  170,     80,   20,  255,  253,    0,    D_EXIT,       0,    0,    "ok" },
   { 0 ,      0,    0,    0,   0,  0,  0,    0,    0,       0,    0, 0}
};


void wham_init();
void init_allegro(int argc);

int main(int argc, char **argv)
{
    //don't use wham dialog , wham not yet initialised -> use allegro dialog

    int WinType;
    int size_x = 300;
    int size_y = 300;
    WinSystem::ShadowSize = 10;
    WinSystem::ShadowColor = makecol(0,0,0);
    init_allegro(argc);


    if (argc == 1)
    {
        popup_dialog(choice,1);

        // the following options have influence on the speed
        WinSystem::Buffered = (choice[1].flags & D_SELECTED);
        WinSystem::UseBoxes = (choice[2].flags & D_SELECTED);
        WinSystem::Full_Remove = (choice[3].flags & D_SELECTED);

        if (choice[4].flags & D_SELECTED)
            WinSystem::ShadowStyle = WHAM_NO_SHADOW;
        if (choice[5].flags & D_SELECTED)
        {
            WinSystem::ShadowStyle = WHAM_SLOW_SHADOW;
            WinSystem::ShadowColor = 100;
        }
        if (choice[6].flags & D_SELECTED)
            WinSystem::ShadowStyle = WHAM_FAST_SHADOW;
        if (choice[7].flags & D_SELECTED)
            WinSystem::ShadowStyle = WHAM_SIMPLE_SHADOW;
        if (choice[8].flags & D_SELECTED)
            WinSystem::ShadowStyle = WHAM_PATTERN_SHADOW;
    
        if (choice[9].flags & D_SELECTED)
            WinType = 0;
        if (choice[10].flags & D_SELECTED)
            WinType = 1;
        if (choice[11].flags & D_SELECTED)
            WinType = 2;
    

    

        // until here    
    }    
    else
    {
        if (argc != 6)
            fatal("Wrong number of options:%d. \n"
                  "usage:\n"
                  "bench <buffered> <use_boxes> <full remove> shadow_style window_style\n"
                  " <> = y or n\n"  
                  "shadow_style is one of: n(o) s(low) f(ast) (s)i(mple) p(attern)\n"
                  "window_style is one of: f(ramewin) b(orderwin) (b)i(llwin)\n",argc);

        WinSystem::Buffered = (argv[1][0] == 'y');
        WinSystem::UseBoxes = (argv[2][0] == 'y');
        WinSystem::Full_Remove = (argv[3][0] == 'y');
        switch(argv[4][0])
        {
            case 'n':
            WinSystem::ShadowStyle = WHAM_NO_SHADOW;
            break;
            case 's':
            {
                WinSystem::ShadowStyle = WHAM_SLOW_SHADOW;
                WinSystem::ShadowColor = 100;
            }
            break;
            case 'f':
            WinSystem::ShadowStyle = WHAM_FAST_SHADOW;
            break;
            case 'i':
            WinSystem::ShadowStyle = WHAM_SIMPLE_SHADOW;
            break;
            case 'p':
            WinSystem::ShadowStyle = WHAM_PATTERN_SHADOW;
            break;
            deafault:
                fatal("wrong option: %c", argv[4][0]);
            break;
        }
        switch(argv[5][0])
        {
            case 'f':
             WinType = 0;
             break;
            case 'b':
             WinType = 1;
             break;
            case 'i':
             WinType = 2;
             break;
            default:
             fatal("wrong option");
             break;
        }

    }



    unsigned long start_time;
    
    unsigned long open_time;
    unsigned long lower_time;
    unsigned long update_time[number_of_objs];
    unsigned long move_time[number_of_objs];

    wham_init();


    if (argc==1)
        WHAM->let_user_choose_gfx_mode();
    Frame *bogus = new Frame(0,0,0,0,"bogus");     // separator to keep p top_locked use frame because it's the smallest class
    
    Panel *p = new Panel(500,20,20,20,"info");


    p->raise_and_lock();
    p->show();
    if (argc != 1)
    {
        Panel *cmdline;
            cmdline = new Panel(400,20,600,20,"Commandline");
            cmdline->lower();
            cmdline->set_lock(TRUE);
            cmdline->printf("buffered use_boxes full_remove shadow window\n");
            cmdline->printf("%c %c %c  %c %c", argv[1][0], argv[2][0], argv[3][0], argv[4][0], argv[5][0]);
            cmdline->show();
    }
    Wobject  *w[number_of_objs]; 
    p->printf("creating %d FrameWin windows sized 500x500\n",number_of_objs);
    p->update();

    start_time = rawclock();
    for (int i=0;i<number_of_objs;i++)
    {
        if (key[KEY_ESC]) exit(1);

        switch(WinType)
        {
            case 0:
                w[i] = new FrameWin(size_x,size_y,10+40*i,10+40*i ,"FrameWin");
            break;
            case 1:
                w[i] = new BorderWin(size_x,size_y,10+40*i,10+40*i ,"BorderWin");
            break;
            case 2:
                w[i] = new BillWin(size_x,size_y,10+40*i,10+40*i ,"BillWin");
            break;
        }
        w[i]->show();
    }
    open_time  = rawclock() - start_time;
    p->printf("lowering top object 100 x\n");
    p->update();
    start_time = rawclock();
    for (int i=0;i<100;i++)
    {
        if (key[KEY_ESC]) exit(1);
        WHAM->get_top_wobject()->lower();
    }
    lower_time  = rawclock() - start_time;
    for (int i=0;i<number_of_objs;i++)
    {
        p->printf("updating window %d 100 times                   \n",i);
        p->update();
        start_time = rawclock();
        for (int j=0;j<100;j++)
        {
            if (key[KEY_ESC]) exit(1);
            clear_to_color(w[i]->bmp(),j );
            w[i]->update();
        }
        update_time[i] = rawclock() - start_time;

    }
    
    for (int i=0;i<number_of_objs;i++)
    {
        p->printf("moving window %d 100 times                   \n",i);
        p->update();
        start_time = rawclock();
        for (int j=0;j<100;j++)
        {
            if (key[KEY_ESC]) exit(1);
            w[i]->move(5*j+10,2*j);
        }
        move_time[i] = rawclock() - start_time;

    }

    Panel *q = new Panel(500,350,20,60,"results");
    q->show();
    q->printf("tics to open %d windows: %ld\n",number_of_objs,open_time);
    q->printf("tics to lower top window 100 times: %ld\n",lower_time);
    for (int i=0;i<number_of_objs;i++)
        q->printf("tics to update window %d 100 times: %ld\n",i,update_time[i]);
    for (int i=0;i<number_of_objs;i++)
        q->printf("tics to move window %d 100 times: %ld\n",i,move_time[i]);
    

    q->update();
    q->raise_and_lock();    

    if (argc == 1) 
        while (!key[KEY_ESC])
            Wham_Secretary.process_mouse();

    delete WHAM;

    if (argc > 1)
    {
        FILE *outfile;
        if (!(outfile = fopen("whambenc.txt","a")))
            fatal("could not write to whambenc.txt");
        long max_update = 0,min_update = 1000000;
        long max_move = 0,min_move = 1000000;
        for (int i=0;i<number_of_objs;i++)
        {
            max_update = MAX(max_update,update_time[i]);
            min_update = MIN(min_update,update_time[i]);
            max_move = MAX(max_move,move_time[i]);
            min_move = MIN(min_move,move_time[i]);
        }
        fprintf(outfile,"Buffered:%c Use_Boxes:%c Full_Remove:%c Shadow:%c Win %c\n"
                " open:%d update:%d-%d move:%d-%d lower top win:%d\n",
                argv[1][0],argv[2][0],argv[3][0],argv[4][0],argv[5][0],
                open_time, max_move,min_move,max_update,min_update,lower_time
                );
        fclose(outfile);
    }

}   


void init_allegro(int argc)
{
    allegro_init();
    install_timer();
    install_keyboard();
    install_mouse();
    if (argc == 1)
    {
        if (set_gfx_mode(GFX_VGA,320,200,0,0))
            fatal("no VGA available: %s",allegro_error);
    }
    else
    {
        if (set_gfx_mode(GFX_AUTODETECT,1024,768,0,0))
            fatal("no 1024x768 available: %s",allegro_error);
    }
    // build a nice palette
    RGB *c = new RGB;
    if (!c)
        out_of_mem("cannot create RGB struct");
    for (int r=0;r<6;r++)    
    for (int g=0;g<6;g++)
    for (int b=0;b<6;b++)
    {
        c->r = r*10;
        c->g = g*10;
        c->b = b*10;
        set_color(r + 6 * g +36 * b,c);
    }
    c->r = c->g = c->b =0;
    for (int i=166;i<251;i++)
        set_color(i,c);

    //white
    c->r = 63;
    c->g = 63;
    c->b = 63;
    set_color(251,c);
    //lgray
    c->r = 45;
    c->g = 45;
    c->b = 45;
    set_color(252,c);
    //gray
    c->r = 35;
    c->g = 35;
    c->b = 35;
    set_color(253,c);
    //dgray
    c->r = 25;
    c->g = 25;
    c->b = 25;
    set_color(254,c);
    //black
    c->r = 0;
    c->g = 0;
    c->b = 0;
    set_color(255,c);
    delete c;


    mouse_on();
}


void wham_init()
{




    WinSystem::InitialBufferSize = 40;  
    WinSystem::Buffer_Increment = 40;
    WinSystem::BackgroundColor= makecol(255,100,100);
    WinSystem::TheScreen = screen;
    WinSystem::Minimum_Size_x = 40;
    WinSystem::Minimum_Size_y = 32;

    
    BorderWin::RemapPalette = TRUE;
    BorderWin::DatafileName = "whamdat.dat";



    WHAM = new WinSystem();
    if (!WHAM)
        out_of_mem("cannot create window manager");

    BillWin::Black_Color = whamgui_black_color = 255;
    BillWin::Dark_Color = Panel::Dark_Outline_Color  =whamgui_dark_color = 254;
    BillWin::Middle_Color = whamgui_middle_color = Panel::Background_Color  = 253;
    BillWin::Light_Color = whamgui_light_color = Panel::Light_Outline_Color = 252;
    BillWin::White_Color = whamgui_white_color = 251;
    BillWin::BorderSize = 2;
    BillWin::Border_Color = 253;
    FrameWin::Border_Color = 255;
    FrameWin::Title_Color = 251;
    FrameWin::Outline_Color = 252;



}

