/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _framewin_h_
#define _framewin_h_
#include <window.h>
#include <sysbox.h>

#define FrameWin_OPAQUE 1
#define FrameWin_CLEAR  2



class FrameWin: public Window
{
    public:
        // constructor
        FrameWin(int size_x,int size_y,int pos_x,int pos_y, char *title);
        FrameWin(BITMAP *bmp,int pos_x,int pos_y,char *title);
        FrameWin(int size_x,int size_y,int pos_x,int pos_y, char *title,WinSystem *its_manager);
        FrameWin(BITMAP *bmp,int pos_x,int pos_y,char *title,WinSystem *its_manager);
        ~FrameWin();
        // sysboxes
        static void add_system_box(BITMAP *bmp,void (*_function)(Wobject *win));
        static void destroy_system_boxes();

        // unused in framewin
        static char *DatafileName; // here for compatability w borderwin
        static int RemapPalette; // here for compatability w borderwin

        // statics that can be set anytime
        static int Move_Style;
        static int Border_Color;
        static int Title_Color;
        static int Outline_Color;

        // process input / messages
        Wobject *process_mouse(int *out_x = NULL, int *out_y = NULL);
    private:
        void create();
        static SystemBox **systemboxes;
        static int number_of_system_boxes;
        static int count;
        static int draw_border(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y);
        static int max_hor_borderlength;

        static BITMAP *upper_border;
};


#endif
