/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_guicon_h_
#define _Wham_guicon_h_

#include "window.h"
#include "whamgui.h"
#define  GUICON_MAGIC_NUMBER  1


class GuiContainer : public Window
{

  public:
      friend void GuiContainer_dclick_check(...);
      // constructor
      GuiContainer(int size_x,int size_y,int pos_x,int pos_y,char *name,DIALOG *d);
      ~GuiContainer();
      //get the object that closed the dialog
      int get_closer_object();

      //start the dialog
      void start(int focus_obj = -1);
      //stop the  dialog
      void stop();

      //is it still busy?
      int is_running();
      static int Border_Color;
      static int Title_Color;
      int process_keyboard();   // virtual
      Wobject *process_mouse(int *x = NULL, int *y = NULL);
      int process_message(Wobject *from, int message);

  private:
       static int nr_of_instances;
       void do_dialog(int key_or_mouse);
       int
            focus_obj,
            it_is_running,
            res,
            obj,
            mouse_obj,
            ox,
            oy,
            joy_on;

        long
            ch;

        DIALOG
            *dialog;




      static int draw_border(BITMAP *onto, Wobject *the_object,int from_x, int from_y, int to_x, int to_y);

};


#endif // end of headerfile
