/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _helpers_h_
#define _helpers_h_
#include <stdio.h>
#include "wobject.h"
#include "topinc.h"
#include "w_mousec.h"



/* some helper functions*/
    void mouse_off();
    void mouse_on();
    void freeze_mouse();
    void thaw_mouse();
    void out_of_mem(char *reason);
    void out_of_mem();
    void fatal(char *format,...);
    void wham_trans_calc_progress(int pos);
    void cleanup_wobjects();
    void trace(char *format,...);
    void ttrace(char *format,...);
    void remap_bitmap(BITMAP *bmp,PALETTE old, int method = 0);
    void w_textout(BITMAP *b,FONT *f, char *c,int x,int y, int color,int mode);
    void w_textout_centre(BITMAP *b,FONT *f, char *c,int x,int y, int color,int mode);
    char *message_string(int message);
    void show_progress(char *msg,int now,int min,int max);

    extern FILE* DEBUG_OUTPUT_FILE;
    Mouse_Cursor *set_Mouse_Cursor(Mouse_Cursor *cursor);
    #ifndef MAX
        #define MAX(x,y) ((x)>(y)?(x):(y))
    #endif
    #ifndef MIN
        #define MIN(x,y) ((x)<(y)?(x):(y))
    #endif

#endif
