/****************************************************************************
 * THIS FILE IS AN Allegro RIP-OFF: all credits to Shawn Hargreaves
 *
 *
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/



#ifndef _WHAMGUI_H_
#define _WHAMGUI_H_


#include "window.h"


#define RAISE_IMMEDIATE       1
#define RAISE_CLICK           2
#define WHAMGUI_DO_KEYS       1
#define WHAMGUI_DO_MOUSE      2

int WHAM_SEND_MESSAGE(DIALOG *d,int msg,int c);

extern BITMAP *wham_guiscreen;

extern int whamgui_raise_style;


/* d_clear_proc:
 *  Simple dialog procedure which just clears the screen. Useful as the
 *  first object in a dialog.
 */
int wham_d_clear_proc(int msg, DIALOG *d, int c);


/* dialog_message:
 *  Sends a message to all the objects in a dialog. If any of the objects
 *  return values other than D_O_K, returns the value and sets obj to the 
 *  object which produced it.
 */
int wham_dialog_message(DIALOG *dialog, int msg, int c, int *obj, Window *container = NULL);


/* d_box_proc:
 *  Simple dialog procedure: just draws a box.
 */
int wham_d_box_proc(int msg, DIALOG *d, int c);


/* d_shadow_box_proc:
 *  Simple dialog procedure: draws a box with a shadow.
 */
int wham_d_shadow_box_proc(int msg, DIALOG *d, int c);


/* d_bitmap_proc:
 *  Simple dialog procedure: draws the bitmap which is pointed to by dp.
 */
int wham_d_bitmap_proc(int msg, DIALOG *d, int c);



/* d_text_proc:
 *  Simple dialog procedure: draws the text string which is pointed to by dp.
 */
int wham_d_text_proc(int msg, DIALOG *d, int c);

/* d_ctext_proc:
 *  Simple dialog procedure: draws the text string which is pointed to by dp,
 *  centering it around the object's x coordinate.
 */
int wham_d_ctext_proc(int msg, DIALOG *d, int c);



/* d_button_proc:
 *  A button object (the dp field points to the text string). This object
 *  can be selected by clicking on it with the mouse or by pressing its 
 *  keyboard shortcut. If the D_EXIT flag is set, selecting it will close 
 *  the dialog, otherwise it will toggle on and off.
 */
int wham_d_button_proc(int msg, DIALOG *d, int c);


/* d_check_proc:
 *  Who needs C++ after all? This is derived from d_button_proc, 
 *  but overrides the drawing routine to provide a check box.
 */
int wham_d_check_proc(int msg, DIALOG *d, int c);

/* d_radio_proc:
 *  GUI procedure for radio buttons.
 *  Parameters: d1-button group number; d2-button style (0=circle,1=square);
 *  dp-text to appear as label to the right of the button.
 */
int wham_d_radio_proc(int msg, DIALOG *d, int c);

/* d_keyboard_proc:
 *  Invisible object for implementing keyboard shortcuts. When its key
 *  is pressed, it calls the function pointed to by dp. This should return
 *  an integer, which will be passed back to the dialog manager. The key
 *  can be specified by putting an ASCII code in the key field or by
 *  putting scancodes in d1 and d2.
 */
int wham_d_keyboard_proc(int msg, DIALOG *d, int c);



/* d_edit_proc:
 *  An editable text object (the dp field points to the string). When it
 *  has the input focus (obtained by clicking on it with the mouse), text
 *  can be typed into this object. The d1 field specifies the maximum
 *  number of characters that it will accept, and d2 is the text cursor 
 *  position within the string.
 */
int wham_d_edit_proc(int msg, DIALOG *d, int c);



/* d_list_proc:
 *  A list box object. The dp field points to a function which it will call
 *  to obtain information about the list. This should follow the form:
 *     char *<list_func_name> (int index, int *list_size);
 *  If index is zero or positive, the function should return a pointer to
 *  the string which is to be displayed at position index in the list. If
 *  index is  negative, it should return null and list_size should be set
 *  to the number of items in the list. The list box object will allow the
 *  user to scroll through the list and to select items list by clicking
 *  on them, and if it has the input focus also by using the arrow keys. If 
 *  the D_EXIT flag is set, double clicking on a list item will cause it to 
 *  close the dialog. The index of the selected item is held in the d1 
 *  field, and d2 is used to store how far it has scrolled through the list.
 */
int wham_d_list_proc(int msg, DIALOG *d, int c);


/* centre_dialog:
 *  Moves all the objects in a dialog so that the dialog is centered in
 *  the screen.
 */
void wham_centre_dialog(DIALOG *dialog);



/* find_dialog_focus:
 *  Searches the dialog for the object which has the input focus, returning
 *  its index, or -1 if the focus is not set. Useful after do_dialog() exits
 *  if you need to know which object was selected.
 */
int wham_find_dialog_focus(DIALOG *dialog);





/* broadcast_dialog_message:
 *  Broadcasts a message to all the objects in the active dialog. If any of
 *  the dialog procedures return values other than D_O_K, it returns that
 *  value.
 */
int wham_broadcast_dialog_message(int msg, int c);



/* do_dialog:
 *  The basic dialog manager. The list of dialog objects should be
 *  terminated by one with a null dialog procedure. Returns the index of 
 *  the object which caused it to exit.
 *  the controll is passed to this dialog, so the rest of the winsystem will
 *  not be updated until this returns
 */
int wham_do_dialog(DIALOG *dialog, int focus_obj, Window *the_object, int persistant = FALSE);

/*
 * as do_dialog, but it creates it's own window(without borders)
 */
int wham_popup_dialog(DIALOG *dialog, int focus_obj, int persistant = 0);

int wham_do_dialog_one_step(DIALOG *dialog,Window *w,int &obj, int &res, int &mouse_obj, long &ch,int &joy_on,int &ox,int &oy,int &focus_obj, int key_or_mouse);




/* menu_alt_key:
 *  Searches a menu for keyboard shortcuts, for the alt+letter to bring
 *  up a menu.
 */
int wham_menu_alt_key(int k, MENU *m);

/* d_3dbutton_proc:
 *  A button object (the dp field points to the text string). This object
 *  can be selected by clicking on it with the mouse or by pressing its 
 *  keyboard shortcut. If the D_EXIT flag is set, selecting it will close 
 *  the dialog, otherwise it will toggle on and off.
 *  it ignores the fg and bg variables and uses the global 
 *  whamgui_*_color variables and gui_mg_color;
 *  
 */
int wham_d_3dbutton_proc(int msg, DIALOG *d, int c);




/* do_menu:
 *  Displays and animates a popup menu at the specified screen position,
 *  returning the index of the item that was selected, or -1 if it was
 *  dismissed. If the menu crosses the edge of the screen it will be moved.
 */
int wham_do_menu(MENU *menu, int x, int y);

int wham_d_3dbox_proc(int msg, DIALOG *d, int c);


/* d_menu_proc:
 *  Dialog procedure for adding drop down menus to a GUI dialog. This 
 *  displays the top level menu items as a horizontal bar (eg. across the
 *  top of the screen), and pops up child menus when they are clicked.
 *  When it executes one of the menu callback routines, it passes the
 *  return value back to the dialog manager, so these can return D_O_K,
 *  D_CLOSE, D_REDRAW, etc.
 */
int wham_d_menu_proc(int msg, DIALOG *d, int c);

// install remove dclick checker (re-entrant)
extern void __wham_install_dclick_check();
extern void __wham_remove_dclick_check();
extern int __wham_mouse_x();
extern int __wham_mouse_y();

extern int whamgui_light_color; // colors
extern int whamgui_middle_color;
extern int whamgui_dark_color;
extern int whamgui_black_color;
extern int whamgui_Text_Color;
extern int whamgui_white_color;

#endif
