/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_pager_h_
#define _Wham_pager_h_

#include <wobject.h>

class Pager : public Wobject
{

  public:

      // ADD CONSTRUCTORS & DESTRUCTORS IF NEEDED
      Pager(int from_x,int from_y,int to_x,int to_y,int scale);

      // this function handles the mouse for this class
      Wobject *process_mouse(int *x = NULL, int *y = NULL);

      static int Border_Color;
      static int Passive_Color;
      static int Active_Color;
      static int Pager_Color;
      static int Background_Color;
      static int Background_Color_Screen;

  private:
      int
        xfrom,
        yfrom,
        xto,
        yto,
        scale;

      void draw(BITMAP *onto,int from_x, int from_y, int to_x, int to_y);

      //IF BORDERS ARE NOT NEEDED REMOVE LINE BELOW, AND CHANGE CONSTRUCTOR
      static int draw_border(BITMAP *onto, Wobject *the_object,int from_x, int from_y, int to_x, int to_y);
      int process_message(Wobject *from, int msg);
};

#endif // end of headerfile
