/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _screens_h_
#define _screens_h_
#ifndef ALLEGRO_H
#include <allegtyp.h> // allegro types
#endif

// my own types for communiating with the dlx
struct COMMSTRUCT
{
   void (*putpixel)(BITMAP *bmp,int x, int y, int c);
   int (*getpixel)(BITMAP *bmp,int x, int y);
   void (*circle)(BITMAP *bitmap,int x, int y, int r, int c);
   void (*circlefill)(BITMAP *bitmap,int x, int y, int r, int c);
   void (*rect)(BITMAP *bitmap,int x, int y, int x2,int y2, int c);
   void (*rectfill)(BITMAP *bitmap,int x, int y, int x2,int y2, int c);
   int  (*makecol)(int,int,int);
   BITMAP *(*create_bitmap)(int,int);
   void (*destroy_bitmap)(BITMAP *bitmap);
   void (*clear_to_color)(BITMAP *,int);
   void (*blit)(BITMAP *, BITMAP *, int, int, int, int, int, int);
   void (*stretch_blit)(BITMAP *, BITMAP *, int, int, int, int, int, int, int, int);
   void (*screensaver)();
   void (*ttrace)(char *format,...);
   void (*line)(BITMAP *,int,int,int,int,int);
   int (*returnchecker)(int init);
   long (*random)();
   void (*vsync)();
   int (*getr)(int col);
   int (*getg)(int col);
   int (*getb)(int col);
   BITMAP *screen;
   int screen_w;
   int screen_h;
};

struct ENTRYSTRUCT
{
    void (*init)(COMMSTRUCT *comm);
    int version_major;
    int version_minor;
    char *screensaver_name;
};

#endif
