/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_scrolbar_h_
#define _Wham_scrolbar_h_

#include <wobject.h>
#define TYPE_VERTICAL_SCROLLBAR 1
#define TYPE_HORIZONTAL_SCROLLBAR 2

class ScrollBar : public Wobject
{

  public:
      //constructor
      ScrollBar(Wobject *onto,int type);

      // processing of input / messages
      Wobject *process_mouse(int *x = NULL, int *y = NULL);
      process_message(Wobject *from,int message);

      // statics that can be changed anytime
      static int White_Color;
      static int Light_Color;
      static int Middle_Color;
      static int Dark_Color;
      static int Black_Color;
  private:
      int bar_length,marker_pos,marker_length;
      void draw(BITMAP *onto,int from_x, int from_y, int to_x, int to_y);
      Wobject *owner;
      int type;

};

#endif // end of headerfile
