/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_wtext_h_
#define _Wham_wtext_h_

#include <helpers.h>
#include <wobject.h>

class TextWindow : public Wobject
{

  public:

      TextWindow(int size_x,int size_y,int pos_x,int pos_y,char *name, FONT *_font = NULL);
		~TextWindow();
      
      Wobject *process_mouse(int *x = NULL, int *y = NULL);
      void printf(int x, int y, char * format, ...); // prints at specified location, does not wrap, does not affect cursor location
      void set_colors(int fg,int bg);
      void printf(char * format, ...);// prints at cursor location, window scrolls up if it reaches bottom, wraps
      void gotoxy(int x,int y); // setc cursor location
      void clear(); // clear window and set cursor to 0,0
      void scrollup(int lines = 1); // scrolls up lines lines

      static int Border_Color;
      static int Title_Color;
  private:
      int bg_color; // -1 = transparent
		int fg_color;

      int cursorx,cursory;
      
      void draw(BITMAP *onto,int from_x, int from_y, int to_x, int to_y);

      static int draw_border(BITMAP *onto, Wobject *the_object,int from_x, int from_y, int to_x, int to_y);
		FONT *its_font;
      int cols,lines;
      char **the_lines;
      
};

#endif // end of headerfile
