
/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include "billwin.h"
#include "window.h"   // needs window for it's sysmenu

void BillWin::draw_sysbox(int which, int checked)
{
    GeoInfo const *g = get_geoinfo();
    BITMAP *TheScreen = get_manager()->get_TheScreen();
    int 
        x = g->pos_x,
        y = g->pos_y;
    switch(which)
    {
        case BILLWIN_MENU_SYSBOX:
            if (checked)
            {
                rect(TheScreen,g->pos_x + 6,g->pos_y - 12,g->pos_x + 12, g->pos_y - 10, White_Color);
                hline(TheScreen,g->pos_x + 7,g->pos_y - 11,g->pos_x + 11, Black_Color);
                hline(TheScreen,g->pos_x + 7,g->pos_y - 9,g->pos_x + 11, Middle_Color);
                vline(TheScreen,g->pos_x + 13,g->pos_y - 10,g->pos_y - 9, Middle_Color);


                rectfill(TheScreen,g->pos_x,g->pos_y - 19,g->pos_x + 17, g->pos_y - 2, Dark_Color);
                //first the white
                putpixel(TheScreen,x + 13,y  - 10,Black_Color);
                putpixel(TheScreen,x + 13,y - 12,Black_Color);
                putpixel(TheScreen,x + 12,y - 11,Black_Color);
                putpixel(TheScreen,x + 11,y - 10,Black_Color);
                putpixel(TheScreen,x + 11,y - 12,Black_Color);
                putpixel(TheScreen,x + 10,y - 10,Black_Color);
                putpixel(TheScreen,x + 9,y - 10,Black_Color);
                putpixel(TheScreen,x + 9,y - 12,Black_Color);
                putpixel(TheScreen,x + 8,y - 11,Black_Color);
                putpixel(TheScreen,x + 7,y - 10,Black_Color);
                putpixel(TheScreen,x + 7,y - 12,Black_Color);
                putpixel(TheScreen,x + 6,y - 12,Black_Color);
                putpixel(TheScreen,x + 5,y - 12,Black_Color);
                putpixel(TheScreen,x + 4,y - 11,Black_Color);
                putpixel(TheScreen,x + 3,y - 10,Black_Color);
                // then the black first the lines
                vline(TheScreen,x + 14, y - 9, y - 13, White_Color);
                hline(TheScreen,x + 4, y - 13, x + 13, White_Color);
                hline(TheScreen,x + 3, y - 12, x + 4, White_Color);
                hline(TheScreen,x + 2, y - 11, x + 3, White_Color);
                hline(TheScreen,x + 5, y - 11, x + 7, White_Color);
                hline(TheScreen,x + 9, y - 11, x + 11, White_Color);
                hline(TheScreen,x + 4, y - 10, x + 6, White_Color);
                hline(TheScreen,x + 2, y - 9, x + 4, White_Color);
                hline(TheScreen,x + 6, y - 9, x + 13, White_Color);
                // then the loose pixels
                putpixel(TheScreen, x + 13, y - 11, White_Color);
                putpixel(TheScreen, x + 12, y - 10, White_Color);
                putpixel(TheScreen, x + 12, y - 12, White_Color);
                putpixel(TheScreen, x + 10, y - 12, White_Color);
                putpixel(TheScreen, x + 8, y - 12, White_Color);
                putpixel(TheScreen, x + 8, y - 10, White_Color);
                putpixel(TheScreen, x + 2, y - 10, White_Color);
                // than the gray
                vline(TheScreen,x + 15, y - 12 , y - 8, Middle_Color);
                hline(TheScreen,x + 7, y - 8, x + 14,Middle_Color); 
                hline(TheScreen,x + 3, y - 8, x + 5,Middle_Color); 

            }
            else
            {
                rectfill(TheScreen,g->pos_x,g->pos_y - 19,g->pos_x + 17, g->pos_y - 2, Middle_Color);
                //first the white
                putpixel(TheScreen,x + 13,y - 10,White_Color);
                putpixel(TheScreen,x + 13,y - 12,White_Color);
                putpixel(TheScreen,x + 12,y - 11,White_Color);
                putpixel(TheScreen,x + 11,y - 10,White_Color);
                putpixel(TheScreen,x + 11,y - 12,White_Color);
                putpixel(TheScreen,x + 10,y - 10,White_Color);
                putpixel(TheScreen,x + 9,y - 10,White_Color);
                putpixel(TheScreen,x + 9,y - 12,White_Color);
                putpixel(TheScreen,x + 8,y - 11,White_Color);
                putpixel(TheScreen,x + 7,y - 10,White_Color);
                putpixel(TheScreen,x + 7,y - 12,White_Color);
                putpixel(TheScreen,x + 6,y - 12,White_Color);
                putpixel(TheScreen,x + 5,y - 12,White_Color);
                putpixel(TheScreen,x + 4,y - 11,White_Color);
                putpixel(TheScreen,x + 3,y - 10,White_Color);
                // then the black first the lines
                vline(TheScreen,x + 14, y - 9, y - 13, Black_Color);
                hline(TheScreen,x + 4, y - 13, x + 13, Black_Color);
                hline(TheScreen,x + 3, y - 12, x + 4, Black_Color);
                hline(TheScreen,x + 2, y - 11, x + 3, Black_Color);
                hline(TheScreen,x + 5, y - 11, x + 7, Black_Color);
                hline(TheScreen,x + 9, y - 11, x + 11, Black_Color);
                hline(TheScreen,x + 4, y - 10, x + 6, Black_Color);
                hline(TheScreen,x + 2, y - 9, x + 4, Black_Color);
                hline(TheScreen,x + 6, y - 9, x + 13, Black_Color);
                // then the loose pixels
                putpixel(TheScreen, x + 13, y - 11, Black_Color);
                putpixel(TheScreen, x + 12, y - 10, Black_Color);
                putpixel(TheScreen, x + 12, y - 12, Black_Color);
                putpixel(TheScreen, x + 10, y - 12, Black_Color);
                putpixel(TheScreen, x + 8, y - 12, Black_Color);
                putpixel(TheScreen, x + 8, y - 10, Black_Color);
                putpixel(TheScreen, x + 2, y - 10, Black_Color);
                // than the gray
                vline(TheScreen,x + 15, y - 12 , y - 8, Dark_Color);
                hline(TheScreen,x + 7, y - 8, x + 14,Dark_Color); 
                hline(TheScreen,x + 3, y - 8, x + 5,Dark_Color); 
                
            }
            break;
        case BILLWIN_MINIM_SYSBOX:
            if (checked)
            {
                rectfill(TheScreen,g->pos_x + g->screen_size_x - 37,g->pos_y - 19,g->pos_x+g->screen_size_x - 20 , g->pos_y - 2, Middle_Color);
                triangle
                (
                    TheScreen,
                    g->pos_x + g->screen_size_x - 33,
                    g->pos_y - 13,
                    g->pos_x + g->screen_size_x - 25,
                    g->pos_y - 13,
                    g->pos_x + g->screen_size_x - 29,
                    g->pos_y - 8,
                    Black_Color
                );
            }
            else
            {
                rectfill(TheScreen,g->pos_x + g->screen_size_x - 36,g->pos_y - 18,g->pos_x+g->screen_size_x - 22 , g->pos_y - 4, Middle_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 37,g->pos_y - 19,g->pos_x+g->screen_size_x - 21,Light_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 37,g->pos_y - 2,g->pos_x+g->screen_size_x - 20,Dark_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 36,g->pos_y - 3,g->pos_x+g->screen_size_x - 20,Dark_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 37,g->pos_y - 18, g->pos_y - 3,Light_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 20,g->pos_y - 19, g->pos_y - 4,Dark_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 21,g->pos_y - 18, g->pos_y - 4,Dark_Color);
                triangle
                (
                    TheScreen,
                    g->pos_x + g->screen_size_x - 32,
                    g->pos_y - 13,
                    g->pos_x + g->screen_size_x - 26,
                    g->pos_y - 13,
                    g->pos_x + g->screen_size_x - 29,
                    g->pos_y - 8,
                    Black_Color
                );
            }

            break;
        case BILLWIN_MAXIM_SYSBOX:
            if (checked)
            {
                rectfill(TheScreen,g->pos_x + g->screen_size_x - 18,g->pos_y - 19,g->pos_x+g->screen_size_x - 1 , g->pos_y - 2, Middle_Color);
                if (state != BILLWIN_STATE_MAXIMISED)
                {
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 8,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 8,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 13,
                        Black_Color
                    );
                }
                else
                {
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 11,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 11,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 15,
                        Black_Color
                    );
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 9,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 9,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 5,
                        Black_Color
                    );
                }
            }
            else
            {
                rectfill(TheScreen,g->pos_x + g->screen_size_x - 17,g->pos_y - 18,g->pos_x+g->screen_size_x - 3 , g->pos_y - 4, Middle_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 18,g->pos_y - 19,g->pos_x+g->screen_size_x - 2,Light_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 18,g->pos_y - 2,g->pos_x+g->screen_size_x - 1,Dark_Color);
                hline(TheScreen,g->pos_x + g->screen_size_x - 17,g->pos_y - 3,g->pos_x+g->screen_size_x - 1,Dark_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 18,g->pos_y - 18, g->pos_y - 3,Light_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 1,g->pos_y - 19, g->pos_y - 4,Dark_Color);
                vline(TheScreen,g->pos_x + g->screen_size_x - 2,g->pos_y - 18, g->pos_y - 4,Dark_Color);
                if (state != BILLWIN_STATE_MAXIMISED)
                {
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 8,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 8,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 13,
                        Black_Color
                    );
                }
                else
                {
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 11,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 11,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 15,
                        Black_Color
                    );
                    triangle
                    (
                        TheScreen,
                        g->pos_x + g->screen_size_x - 14,
                        g->pos_y - 9,
                        g->pos_x + g->screen_size_x - 6,
                        g->pos_y - 9,
                        g->pos_x + g->screen_size_x - 10,
                        g->pos_y - 5,
                        Black_Color
                    );
                }
            
            
            }

            break;
    }
}

Wobject *BillWin::process_mouse(int *x_out = NULL, int *y_out = NULL)
{
    Wobject *win; 
    int out_x,out_y,mouse_was_x,mouse_was_y,pos_was_x,pos_was_y,mouse_is_x,mouse_is_y,size_was_x,size_was_y; // helper variables
    int flag; // is the border clicked?
    GeoInfo const *g; // to store geoinfo from object in

    //get the object the mouse is currently in( if flag is set it is in a border)
    //out_x, out_y will be the coordinates relative to that object 
    win =WHAM->process_coordinates(mouse_x,mouse_y,&out_x,&out_y,&flag);

    //store coordinates relative to this object if the user wants them
    if (x_out)
        *x_out = out_x;
    if (y_out)
        *y_out = out_y;
    if (win != this)
        return win;

    g = win->get_geometric_info(); // get info on this object into g 

    switch(((BillWin *)win)->state)
    {
      case BILLWIN_STATE_MINIMISED:
        if (mouse_b & 1)
        {

           g = win->get_geometric_info(); // get info on this object into g 
           mouse_was_x = mouse_x; //store current mouse position
           mouse_was_y = mouse_y;
           pos_was_x = g->pos_x; //store current object location 
           pos_was_y = g->pos_y;
           size_was_x = g->screen_size_x;//store current object size
           size_was_y = g->screen_size_y;
    
           //if the window has a parent manager, the parent window could be rescaled   
           //so calc the mouse position relative to the parent window
           if (win->get_manager()->get_parent())
               win->get_manager()->get_parent()->transform_coordinates(&mouse_was_x,&mouse_was_y);
           while (mouse_b & 1)
           {
                mouse_is_x = mouse_x; // get current mouse pos
                mouse_is_y = mouse_y;
                // calc current mouse pos relative to parent win
                if (win->get_manager()->get_parent())
                    win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);
                // and move the window
                win->move(pos_was_x + mouse_is_x - mouse_was_x,pos_was_y + mouse_is_y - mouse_was_y);
           }
        }
        else
        {
            if (mouse_b & 2)
            {
                set_state(last_state);

            }
        }
        break;
      case BILLWIN_STATE_MAXIMISED:
        if (mouse_b & 1)
        {
            if  (flag)
            {
                if (out_y <0)
                {
                        if (out_x < 18)
                        {
                            draw_sysbox(BILLWIN_MENU_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            sys_menu();
                        }
                        else if (out_x < g->screen_size_x - 19 && out_x > g->screen_size_x - 37)
                        {
                            draw_sysbox(BILLWIN_MINIM_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            while (mouse_b & 1);
                            set_state(BILLWIN_STATE_MINIMISED);
                        }
                        else if (out_x > g->screen_size_x - 19)
                        {
                            draw_sysbox(BILLWIN_MAXIM_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            while (mouse_b & 1);

                            if (state == BILLWIN_STATE_MAXIMISED)
                                set_state(BILLWIN_STATE_MEDIUMISED);
                            else
                                set_state(BILLWIN_STATE_MAXIMISED);

                        }
                 }
            }
            else
            {
                raise();
            }
        }
        break;
      case BILLWIN_STATE_MEDIUMISED:
        if (flag)
        {
            if (out_y <0 && out_x > 18 && out_x < g->screen_size_x - 39)
                set_Mouse_Cursor(WinSystem::Mouse_Cursor1);
            else if(out_y >0)
                set_Mouse_Cursor(WinSystem::Mouse_Cursor2);
        }
        else
            set_Mouse_Cursor(WinSystem::Mouse_Cursor0);

        // mouse button 1 is currently pressed down
        if (mouse_b & 1)
        {
           mouse_was_x = mouse_x; //store current mouse position
           mouse_was_y = mouse_y;
           pos_was_x = g->pos_x; //store current object location 
           pos_was_y = g->pos_y;
           size_was_x = g->screen_size_x;//store current object size
           size_was_y = g->screen_size_y;
    
           //if the window has a parent manager, the parent window could be rescaled   
           //so calc the mouse position relative to the parent window
           if (win->get_manager()->get_parent())
               win->get_manager()->get_parent()->transform_coordinates(&mouse_was_x,&mouse_was_y);
    
           if (flag) // mouse is on a border 
           {
               if (out_y <0) // left or upper border -> move or clivk checkbox
               {
                    if (out_x > 18 && out_x < g->screen_size_x - 39)
                    {
                        while (mouse_b & 1)
                        {
                            mouse_is_x = mouse_x; // get current mouse pos
                            mouse_is_y = mouse_y;
                            // calc current mouse pos relative to parent win
                            if (win->get_manager()->get_parent())
                                win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);
                            // and move the window
                            move(pos_was_x + mouse_is_x - mouse_was_x,pos_was_y + mouse_is_y - mouse_was_y);
                        }
                    }
                    else  //clicked sysbox
                    {
                        if (out_x < 18)
                        {
                            draw_sysbox(BILLWIN_MENU_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            sys_menu();

                        }
                        else if (out_x < g->screen_size_x - 19)
                        {
                            draw_sysbox(BILLWIN_MINIM_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            while (mouse_b & 1);
                            set_state(BILLWIN_STATE_MINIMISED);
                        }
                        else
                        {
                            draw_sysbox(BILLWIN_MAXIM_SYSBOX,TRUE);
                            get_manager()->update_screen
                            (
                                get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,
                                get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size,
                                get_geoinfo()->pos_x +get_geoinfo()->screen_size_x+get_geoinfo()->Right_Border_Size,
                                get_geoinfo()->pos_y
                            );
                            while (mouse_b & 1);
                            if (state == BILLWIN_STATE_MAXIMISED)
                                set_state(BILLWIN_STATE_MEDIUMISED);
                            else
                                set_state(BILLWIN_STATE_MAXIMISED);

                        }
                    }
               }
               else // left or lower border -> rescale/resie_viewport
               {
                   while (mouse_b & 1)
                   {
                       mouse_is_x = mouse_x;// get current mosue pos
                       mouse_is_y = mouse_y;
                       // make mouse pos relative to parent window
                       if (win->get_manager()->get_parent())
                           win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);
                       //rescale the object
                       if (flags & BILLWIN_STYLE_RESCALE)
                         rescale(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);
                       else
                         resize_s_viewport(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);
                   }
               }
           }
           else // flag =0 -> clicked in the window
                win->raise();
        }
        break;
    }


    if (!flag) 
        return (Wobject *)win;
    else
        return NULL;
}



int BillWin::draw_border(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y)
{

    int
        f_x,f_y,t_x,t_y;
    if (!onto) // return border dimensions to manager
    {
        switch(from_x)
        {
            case WINDOW_UPPER_BORDER:
                return 21 + BorderSize;
            break;
            case WINDOW_LOWER_BORDER:
                return BorderSize + 2;
            break;
            case WINDOW_LEFT_BORDER:
                return BorderSize + 2;
            break;
            case WINDOW_RIGHT_BORDER:
                return BorderSize + 2;
            break;
        }

    }

    if (((BillWin *)the_object)->get_state() == BILLWIN_STATE_MINIMISED)
        return 0;
    GeoInfo const *g = the_object->get_geoinfo();


    //upper border , blue bar
    f_x = g->pos_x +19;
    t_x = g->pos_x + g->screen_size_x - 39;
    f_y = g->pos_y - 19;      
    t_y = g->pos_y - 2;           
                              
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x <= t_x && f_y <= t_y) 
        rectfill(onto,f_x,f_y,t_x,t_y,Bar_Color);
    text_mode(Bar_Color);
    textout_centre(onto,font,g->name,g->pos_x + g->screen_size_x/2, g->pos_y - 13, Black_Color);


    // upper border, fill border
    f_x = g->pos_x - g->Left_Border_Size + 1;
    t_x = g->pos_x + g->screen_size_x +g->Right_Border_Size - 1;
    f_y = g->pos_y - g->Upper_Border_Size + 1;      
    t_y = g->pos_y - 20;           
                              
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x <= t_x && f_y <= t_y) 
        rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    // lower border, fill border
    f_x = g->pos_x - g->Left_Border_Size + 1;
    t_x = g->pos_x + g->screen_size_x +g->Right_Border_Size - 2;
    f_y = g->pos_y + g->screen_size_y + 1;
    t_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 2;      
                              
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x <= t_x && f_y <= t_y) 
        rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    // left border, fill border
    f_x = g->pos_x - g->Left_Border_Size + 1;
    t_x = g->pos_x - 2;
    f_y = g->pos_y - 20;
    t_y = g->pos_y + g->screen_size_y;      
                              
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x <= t_x && f_y <= t_y) 
        rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    // right border, fill border
    f_x = g->pos_x + g->screen_size_x + 1;
    t_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 2;
    f_y = g->pos_y - 20;
    t_y = g->pos_y + g->screen_size_y;      
                              
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x <= t_x && f_y <= t_y) 
        rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
     


    // the lines                                           
    // top line
    f_x = g->pos_x - g->Left_Border_Size;
    t_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 1;
    f_y = g->pos_y - g->Upper_Border_Size;

    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);
    // one below
    f_x = g->pos_x - 1;
    t_x = g->pos_x + g->screen_size_x;
    f_y = g->pos_y - 20;

    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);

    // bottom line of top border
    f_x = g->pos_x - g->Left_Border_Size;
    t_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 1;
    f_y = g->pos_y - 1;

    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);

    // right line of left sysbox
    f_x = g->pos_x + 18;
    f_y = g->pos_y - g->Upper_Border_Size;
    t_y = g->pos_y - 1;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);
    
    // left line of leftmost of right sysboxes
    f_x = g->pos_x + g->screen_size_x - 38;
    f_y = g->pos_y - 19;
    t_y = g->pos_y - 1;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);

    // right line of leftmost of right sysboxes
    f_x = g->pos_x + g->screen_size_x - 19;
    f_y = g->pos_y - g->Upper_Border_Size;
    t_y = g->pos_y - 1;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);


    // bottom line of bottom border
    f_x = g->pos_x - g->Left_Border_Size;
    t_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 1;
    f_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 1;

    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);

    // top line of bottom border
    f_x = g->pos_x - 1;
    t_x = g->pos_x + g->screen_size_x;
    f_y = g->pos_y + g->screen_size_y;

    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);

    //leftmost line of left border
    f_x = g->pos_x - g->Left_Border_Size ;
    f_y = g->pos_y - g->Upper_Border_Size;
    t_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 1;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);

    //right line of left border
    f_x = g->pos_x - 1;
    f_y = g->pos_y - 19;
    t_y = g->pos_y + g->screen_size_y;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);
    
    //leftmost line of right border
    f_x = g->pos_x + g->screen_size_x ;
    f_y = g->pos_y - 19;
    t_y = g->pos_y + g->screen_size_y;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);

    //right line of right border
    f_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 1;
    f_y = g->pos_y - g->Upper_Border_Size;
    t_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 1;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);

    //bottom corners
    // left vert
    f_x = g->pos_x + 18;
    f_y = g->pos_y + g->screen_size_y + 1;
    t_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 2;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);

    // right vert
    f_x = g->pos_x + g->screen_size_x - 19;
    f_y = g->pos_y + g->screen_size_y + 1;
    t_y = g->pos_y + g->screen_size_y + g->Lower_Border_Size - 2;
    f_y = MAX(f_y, from_y);   
    t_y = MIN(t_y, to_y);     
    if (f_x>=from_x && f_y <= t_y)
        vline(onto,f_x,f_y,t_y,Black_Color);
    
    //left hor
    f_x = g->pos_x - g->Left_Border_Size + 1;
    t_x = g->pos_x - 2;
    f_y = g->pos_y + g->screen_size_y - 19;
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);
    //right hor
    f_x = g->pos_x + g->screen_size_x + 1;
    t_x = g->pos_x + g->screen_size_x + g->Right_Border_Size - 2;
    f_y = g->pos_y + g->screen_size_y - 19;
    f_x = MAX(f_x, from_x);   
    t_x = MIN(t_x, to_x);     
    if (f_x<=t_x && f_y >= from_y)
        hline(onto,f_x,f_y,t_x,Black_Color);

    ((BillWin *)the_object)->draw_sysbox(BILLWIN_MENU_SYSBOX,FALSE);
    ((BillWin *)the_object)->draw_sysbox(BILLWIN_MINIM_SYSBOX,FALSE);
    ((BillWin *)the_object)->draw_sysbox(BILLWIN_MAXIM_SYSBOX,FALSE);

    return 0; //returnvalue currently ignored 
}




BillWin::BillWin(int size_x,int size_y,int pos_x,int pos_y,char *name,int _flags = 0)
    : Wobject(name,size_x,size_y,pos_x,pos_y, BillWin::draw_border)
{
    BITMAP *bmp = create_bitmap(size_x, size_y);
    if (!bmp) fatal("WHAM:out of memory while creating Wobject buffer");
    must_delete_bitmap = TRUE;
    create(bmp);
    flags = _flags;
}

BillWin::BillWin(int size_x,int size_y,int pos_x,int pos_y,char *name, WinSystem *its_manager,int _flags = 0)
      : Wobject(name,size_x,size_y,pos_x,pos_y,its_manager, BillWin::draw_border)
{
    BITMAP *bmp = create_bitmap(size_x, size_y);
    if (!bmp) fatal("WHAM:out of memory while creating Wobject buffer");
    must_delete_bitmap = TRUE;
    create(bmp);
    flags = _flags;
}


BillWin::~BillWin()
{
    destroy();
}

void BillWin::create(BITMAP *bmp)
{

    number_of_instances++;
    window = bmp;
    if (must_delete_bitmap) clear(window); // it is a new one
    user = create_sub_bitmap(window, 0, 0, get_geoinfo()->size_x, get_geoinfo()->size_y);
    text_cursor_x = text_cursor_y = 1;
    clear_to_color(window,White_Color);
    state = BILLWIN_STATE_MEDIUMISED;
    if (!standard_icon)
    {
        int 
            dim_x= get_geoinfo()->Left_Border_Size +  get_geoinfo()->Right_Border_Size + get_manager()->Minimum_Size_x,
            dim_y= get_geoinfo()->Lower_Border_Size +  get_geoinfo()->Upper_Border_Size + get_manager()->Minimum_Size_y,
            dim = MAX(dim_x,dim_y);

        standard_icon = create_bitmap(dim,dim);
        if (!standard_icon)
            out_of_mem("standard icon");
        clear_to_color(standard_icon,Dark_Color);
        for (int i=0;i<(dim/2);i++)
        {
            circle(standard_icon,dim/2,dim/2,i,i);
            circle(standard_icon,dim/2,dim/2+1,i,i);
        }
        text_mode(-1);
        textout_centre(standard_icon,font,"right",dim/2,dim/2-8,0);
        textout_centre(standard_icon,font,"click",dim/2,dim/2+8,0);

    }
    icon = standard_icon;
}

void BillWin::destroy()
{
    number_of_instances--;
    if (!number_of_instances)
    {
        destroy_bitmap(standard_icon);
        standard_icon = NULL;
    }
    destroy_bitmap(user);            // free memory of buffers
    if (must_delete_bitmap)
        destroy_bitmap(window);

}


/*************************************************************
 * draws the portion of the window that is inside the rectangle
 * given by the coordinates
 *************************************************************/
void BillWin::draw(BITMAP *onto, int from_x, int from_y, int to_x, int to_y)
{
    #ifdef _DEBUG_OUTPUT
        fprintf(stderr,"WINDOW %d draw %d %d %d %d\n",get_geoinfo()->tag,from_x,from_y,to_x,to_y);
    #endif


    #ifdef TRACE
        if (wham_trace) trace("draw %d",get_geoinfo()->tag);
    #endif


             
    if (state == BILLWIN_STATE_MINIMISED)
    {
        draw_sprite(onto,icon,get_geoinfo()->pos_x - get_geoinfo()->Left_Border_Size,get_geoinfo()->pos_y - get_geoinfo()->Upper_Border_Size);
        return;
    }
             

    int
        w_from_x,
        w_from_y,
        w_to_x,
        w_to_y;

    //readkey();
    //adjust coordinates on screen
    from_x = MAX(get_geoinfo()->pos_x,from_x);
    from_y = MAX(get_geoinfo()->pos_y,from_y);
    to_x = MIN(to_x,get_geoinfo()->pos_x + get_geoinfo()->screen_size_x - 1);
    to_y = MIN(to_y,get_geoinfo()->pos_y + get_geoinfo()->screen_size_y - 1);
    
    // get coordinates in wobject
    w_from_x = get_geoinfo()->viewport_pos_x + (int)((from_x - get_geoinfo()->pos_x) * (float)get_geoinfo()->viewport_size_x / (float)get_geoinfo()->screen_size_x);
    w_to_x = get_geoinfo()->viewport_pos_x + (int)((to_x - get_geoinfo()->pos_x) * (float)get_geoinfo()->viewport_size_x / (float)get_geoinfo()->screen_size_x);
    w_from_y = get_geoinfo()->viewport_pos_y + (int)((from_y - get_geoinfo()->pos_y) * (float)get_geoinfo()->viewport_size_y / (float)get_geoinfo()->screen_size_y);
    w_to_y = get_geoinfo()->viewport_pos_y + (int)((to_y - get_geoinfo()->pos_y) * (float)get_geoinfo()->viewport_size_y / (float)get_geoinfo()->screen_size_y);
    #ifdef _DEBUG_OUTPUT
        fprintf (stderr,"\n    on screen %d %d %d %d in wobject %d %d %d %d \n"
                        "       position %d %d\n",
                from_x,from_y,to_x,to_y,w_from_x,w_from_y,w_to_x,w_to_y,
                get_geoinfo()->pos_x,get_geoinfo()->pos_y
                );
    #endif
    
    
    
    if (w_to_x >= w_from_x && w_to_y >= w_from_y)
    {
        if (get_geoinfo()->screen_size_x != get_geoinfo()->viewport_size_x || get_geoinfo()->screen_size_y != get_geoinfo()->viewport_size_y)
        {
            stretch_blit
            (
                window,
                onto,
                w_from_x,
                w_from_y,
                w_to_x - w_from_x + 1,
                w_to_y - w_from_y + 1,
                from_x,
                from_y,
                to_x - from_x + 1,
                to_y - from_y + 1
            );
        }
        else
        {
            blit
            (
                window,
                onto,
                w_from_x,
                w_from_y,
                from_x,
                from_y,
                to_x - from_x + 1,
                to_y - from_y + 1

            );
        }
    }
    #ifdef _DEBUG_OUTPUT
        fprintf(stderr,"drew Wobject %d\n",get_geoinfo()->tag);
    #endif

}

/*************************************************************
 * set the size & position of the user area
 *************************************************************/
void BillWin::set_user_area(int _pos_x,int _pos_y,int _size_x, int _size_y)
{
    #ifdef TRACE
        if (wham_trace) trace("Wobject::set_user_area");
    #endif

    // get everything within boundaries with some ternair monsters
    _pos_x = _pos_x < 0 ? 0 : _pos_x >= get_geoinfo()->size_x ? get_geoinfo()->size_x-1 : _pos_x;
    _pos_y = _pos_y < 0 ? 0 : _pos_y >= get_geoinfo()->size_y ? get_geoinfo()->size_y-1 : _pos_y;
    _size_x = _size_x < 0 ? 0 : _size_x + _pos_x >= get_geoinfo()->size_x ? get_geoinfo()->size_x - _pos_x: _size_x;
    _size_y = _size_y < 0 ? 0 : _size_y + _pos_y >= get_geoinfo()->size_y ? get_geoinfo()->size_y - _pos_y: _size_y;

    Wobject::set_user_area(_pos_x, _pos_y,_size_x,_size_y);

    destroy_bitmap(user);
    user = create_sub_bitmap(window,  get_geoinfo()->user_pos_x,  get_geoinfo()->user_pos_y, get_geoinfo()->user_size_x, get_geoinfo()->user_size_y);
}





/*************************************************************
 * resize the bitmap, note that is means making a new bitmap
 * and copying the old one
 * the information inside the window is not rescaled
 * use rescale for that
 *************************************************************/
int BillWin::resize(int nw_size_x,int nw_size_y)
{
    #ifdef TRACE
        if (wham_trace) trace("Wobject::resize");
    #endif


    Wobject::resize(nw_size_x,nw_size_y);
    nw_size_x = get_geoinfo()->size_x;    
    nw_size_y = get_geoinfo()->size_y;    


    BITMAP *nw = create_bitmap(nw_size_x, nw_size_y);
    if (!nw) 
        fatal("WHAM:out of memory while creating window buffer for resizing");

    blit(window, nw, 0,0,0,0,nw_size_x, nw_size_y);


    destroy_bitmap(user);
    if (must_delete_bitmap)
        destroy_bitmap(window);
    window = nw;
    user = create_sub_bitmap(window,  get_geoinfo()->user_pos_x,  get_geoinfo()->user_pos_y, get_geoinfo()->user_size_x, get_geoinfo()->user_size_y);
    
    Wobject::notify_children();


    return TRUE;// return success
}




BITMAP *BillWin::bmp() 
{
    return user;
}


int BillWin::printf(char *format,...)
{
    static char buffer[2048];

    va_list arg;
    va_start(arg,format);
    int ret = vsprintf(buffer,format,arg);
    va_end(arg);

    char *ent = buffer;
    char *head = buffer;
    int nr_of_enters = 0;

    text_mode(White_Color);
    while(*ent)
    {
        if (*ent == 10) nr_of_enters++;
        ent++;
    }
    ent = buffer;
    for (int i=0;i<nr_of_enters;i++)
    {
        // look up enter
        while(*ent++ != 10);
        *(--ent) = 0;
        textout(user,font,head,text_cursor_x,text_cursor_y,Text_Color);
        head = ++ent;
        text_cursor_x = 1;
        text_cursor_y += text_height(font) + 2;
        if (text_cursor_y>get_geoinfo()->size_y - text_height(font))
        {
            text_cursor_y=1;
        }
    }
    textout(user,font,head,text_cursor_x,text_cursor_y, Text_Color);
    text_cursor_x += text_length(font, head);

    return ret;
}

int BillWin::Text_Color = 255;





int BillWin::Black_Color = 0;
int BillWin::Dark_Color = 1;
int BillWin::Middle_Color = 2;
int BillWin::Light_Color = 3;
int BillWin::White_Color = 4;
int BillWin::Bar_Color = 5;
int BillWin::Border_Color = 6;
int BillWin::BorderSize = 2;

void BillWin::set_state(int _state)
{
    if (_state == state)
        return;

    int max_size_x = get_manager()->get_TheScreen_size_x() - get_geoinfo()->Left_Border_Size - get_geoinfo()->Right_Border_Size;
    int max_size_y = get_manager()->get_TheScreen_size_y() - get_geoinfo()->Upper_Border_Size - get_geoinfo()->Lower_Border_Size;

    if (state == BILLWIN_STATE_MEDIUMISED)
    {
        med_size_x= get_geoinfo()->screen_size_x;
        med_size_y= get_geoinfo()->screen_size_y;
        med_pos_x = get_geoinfo()->pos_x;
        med_pos_y = get_geoinfo()->pos_y;
    }
    if (_state == BILLWIN_STATE_MEDIUMISED || _state == BILLWIN_STATE_MINIMISED)
    {
        set_lock_viewport_size(FALSE);
        set_lock_scale(FALSE);
        set_lock_position(FALSE);
    }
    last_state = state;
    state = _state;

    switch(state)
    {
        case BILLWIN_STATE_MAXIMISED:
            see_through = FALSE;
            if (flags & BILLWIN_STYLE_RESCALE)
                rescale(max_size_x,max_size_y);
            else
                resize_s_viewport(max_size_x,max_size_y);

            move(get_geoinfo()->Left_Border_Size,get_geoinfo()->Upper_Border_Size);
            raise();
            set_lock_scale(TRUE);
            set_lock_viewport_size(TRUE);
            set_lock_position(TRUE);
            break;
        case BILLWIN_STATE_MEDIUMISED:
            see_through = FALSE;
            if (flags & BILLWIN_STYLE_RESCALE)
                rescale(med_size_x,med_size_y);
            else
                resize_s_viewport(med_size_x,med_size_y);

            move(med_pos_x,med_pos_y);
            break;
        case BILLWIN_STATE_MINIMISED:
            see_through = TRUE;
            if (flags & BILLWIN_STYLE_RESCALE)
                rescale(icon->w - get_geoinfo()->Left_Border_Size - get_geoinfo()->Right_Border_Size,
                        icon->h - get_geoinfo()->Upper_Border_Size - get_geoinfo()->Lower_Border_Size);
            else
                resize_s_viewport(icon->w - get_geoinfo()->Left_Border_Size - get_geoinfo()->Right_Border_Size,
                        icon->h - get_geoinfo()->Upper_Border_Size - get_geoinfo()->Lower_Border_Size);
            break;
    }

}

int BillWin::get_state()
{
    return state;
}

BITMAP *BillWin::standard_icon = NULL;

void BillWin::set_icon(BITMAP *sprite)
{
    if (sprite->w < WinSystem::Minimum_Size_x + get_geoinfo()->Left_Border_Size + get_geoinfo()->Right_Border_Size 
        || sprite->h < WinSystem::Minimum_Size_y + get_geoinfo()->Lower_Border_Size + get_geoinfo()->Upper_Border_Size )
              trace("Icon for window %s too small(press a key)",get_geoinfo()->name);

    icon = sprite;
    if (!icon)
        icon = standard_icon;
}


void BillWin::sys_menu()
{
    GeoInfo const *g = get_geometric_info();
    int pos_x = MIN(g->pos_x ,WHAM->get_TheScreen_size_x() - 100);
    int pos_y = MIN(g->pos_y ,WHAM->get_TheScreen_size_y() - 32);
    pos_x = MAX(pos_x,0);
    pos_y = MAX(pos_y,0);
    int x,y,flag;
    text_mode(White_Color);
    Window *Menu = new Window("menu",100,32,pos_x,pos_y,get_manager());
    if (!Menu)
        out_of_mem("cannot create menu window");
    Menu->raise_and_lock();
    Window * the_win;
    clear_to_color(Menu->bmp(),White_Color);
    text_mode(-1);
    rect(Menu->bmp(),0,0,99,31,Black_Color);
    textout(Menu->bmp(),font,"Maximise", 3,3,Text_Color);
    textout(Menu->bmp(),font,"Minimise", 3,13,Text_Color);
    textout(Menu->bmp(),font,"Hide", 3,23,Text_Color); 
    Menu->show();
    while (mouse_b & 1);
    while (!(mouse_b & 1));
    
    the_win =(Window *)WHAM->process_coordinates(mouse_x,mouse_y,&x,&y,&flag);

    if (the_win == Menu && !flag)
    {
        if (y < 12 )
           set_state(BILLWIN_STATE_MAXIMISED);
        else if (y < 22 )
           set_state(BILLWIN_STATE_MINIMISED);
        else if (y < 32 )
           hide();
    }
    delete Menu;
    update();
}


int BillWin::number_of_instances = 0;
