/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#include <stdio.h>
#include <strings.h>
#include "helpers.h"
#include "geoinfo.h"


GeoInfo::GeoInfo()
{
    name = NULL;
}
GeoInfo::~GeoInfo()
{
    destroy();
}

void GeoInfo::destroy()
{ 
    if (name) 
    {
        delete name;
        name =NULL;
    }
}
        
GeoInfo::GeoInfo(GeoInfo const &other)
{
    create(other);
}

void GeoInfo::create(GeoInfo const &other)
{
    size_x = other.size_x;
    size_y = other.size_y;
    viewport_size_x = other.viewport_size_x;
    viewport_size_y = other.viewport_size_y;
    viewport_pos_x = other.viewport_pos_x;
    viewport_pos_y = other.viewport_pos_y;
    screen_size_x = other.screen_size_x;
    screen_size_y = other.screen_size_y;
    user_size_x  = other.user_size_x;
    user_size_y = other.user_size_y;
    pos_x = other.pos_x;
    pos_y = other.pos_y;
    user_pos_x = other.user_pos_x;
    user_pos_y = other.user_pos_y;
    tag = other.tag;
    is_locked = other.is_locked;
    size_is_locked = other.size_is_locked;
    pos_is_locked = other.pos_is_locked;
    scale_is_locked = other.scale_is_locked;
    shift_is_locked = other.shift_is_locked;
    visibility_is_locked = other.visibility_is_locked;
    viewport_pos_is_locked = other.viewport_pos_is_locked;
    viewport_size_is_locked = other.viewport_size_is_locked;
    Upper_Border_Size = other.Upper_Border_Size;
    Lower_Border_Size = other.Lower_Border_Size;
    Right_Border_Size = other.Right_Border_Size;
    Left_Border_Size = other.Left_Border_Size;
    is_displayed = other.is_displayed;
    scale_x = other.scale_x;
    scale_y = other.scale_y;
    if (other.name)
        name = strdup(other.name);
    else
        name = NULL;
}

GeoInfo const &GeoInfo::operator=(GeoInfo const &other)
{ 
    if (this != &other) 
    { 
        destroy(); 
        create(other);
    } 
    return *this;
}

