/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#include <oclock.h>
#include <dos.h>

OClock::OClock(int radius,int pos_x,int pos_y)
      : Wobject("OClock",2*radius,2*radius,pos_x,pos_y)
{
    see_through = TRUE;
    Wham_Secretary.schedule(OClock::updater,this,1);
}

int OClock::Fg_Color = 0;
int OClock::Bg_Color = 255;

int OClock::updater(void *cl)
{
    ((OClock *)cl)->update();
    return 0;
}

void OClock::draw(BITMAP *onto, int f_x, int f_y,int t_x, int t_y)
{
    time t;
    gettime(&t);
    f_x = f_y =t_x =t_y = 0; //unused rely on clipping by winsystem

    fix shandangle = (t.ti_hour % 12) *255 / 12;
    fix bhandangle = (t.ti_min % 60) *255 / 60;
    fix secangle =(t.ti_sec % 60) *255 / 60;
    int cx = get_geoinfo()->pos_x+get_geoinfo()->screen_size_x/2;
    int cy = get_geoinfo()->pos_y+get_geoinfo()->screen_size_y/2;
    int r = get_geoinfo()->screen_size_y/2;

    circlefill(onto,cx,cy,r -1, Bg_Color);
    circle(onto,cx,cy,r -1,Fg_Color);
    line(onto,cx,cy, cx + (r* 3/4) * sin(bhandangle),cy - (r * 3/4) * cos(bhandangle),Fg_Color);
    line(onto,cx,cy, cx + (r /3) * sin(shandangle),cy - (r /3) * cos(shandangle),Fg_Color);
    line(onto,cx,cy, cx + (r /2) * sin(secangle),cy - (r /3) * cos(secangle),Fg_Color);
}


// IDENTIFICATION FUNCTIONS, DO NOT ALTER


int OClock::inquire_mouse(int pos_x,int pos_y)
{
    GeoInfo const *g = get_geoinfo();
    int r = g->size_x/2;
    pos_x -= r;
    pos_y -= r;
    if ((pos_x*pos_x)+(pos_y*pos_y) <= (r*r))
        return TRUE;

    return FALSE;

}




int OClock::_ident = -1;


// NOTE this mouse function doesn't work if the OClocks are inside a parent window
// because it uses mouse_x and mouse_y directly instead of first transforming
// them to the coordinates of the parent window

Wobject *OClock::process_mouse(int *x_out = NULL, int *y_out = NULL)
{
    Wobject *win; 
    int out_x,out_y,mouse_was_x,mouse_was_y,pos_was_x,pos_was_y; // helper variables
    int flag; // is the border clicked?

    //get the object the mouse is currently in( if flag is set it is in a border)
    //out_x, out_y will be the coordinates relative to that object 
    win =WHAM->process_coordinates(mouse_x,mouse_y,&out_x,&out_y,&flag);

    //store coordinates relative to this object if the user wants them
    if (x_out)
        *x_out = out_x;
    if (y_out)
        *y_out = out_y;
    if (win != this)
        return win;
    if (mouse_b)
    {
        win->raise();
        mouse_was_x = mouse_x;
        mouse_was_y = mouse_y;
        pos_was_x = win->get_geoinfo()->pos_x;
        pos_was_y = win->get_geoinfo()->pos_y;
        while (mouse_b)
            (OClock *)win->move(pos_was_x+mouse_x-mouse_was_x,pos_was_y+mouse_y-mouse_was_y);
    }
    return win;
}
