/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#include <sys/dxe.h>
#include <helpers.h>
#include <allegro.h>
#include <screensv.h>
#include <wversion.h>
#include <scrsav.h>
#include <stdlib.h>

static int deflt();


static int omouse_x,omouse_y;

static int retcheck(int init)
{
	if (init)
	{
		omouse_x = mouse_x;
		omouse_y = mouse_y;
		return 0;
	}

	if (mouse_x != omouse_x) return 1;
	if (mouse_y != omouse_y) return 1;
	if (mouse_b) return 2;
	if (keypressed()) return 3;
	return 0;
}

__screensavertype load_screensaver(char *filename, char **screensaver_name)
{
	void (*init)(COMMSTRUCT *info);
	void (*screensaver)();
	ENTRYSTRUCT *entry;
	entry = (ENTRYSTRUCT *)_dxe_load(filename);
	if (!entry)
	{
		return NULL;
	}
	if (entry->version_major != VERSION_MAJOR || entry->version_minor != VERSION_MINOR)
	{
		PALETTE p;
		get_palette(p);
		set_palette(desktop_palette);
		alert("Screensaver has the wrong version number", 
			   "It needs to be recompiled with WHAM version:",
			   VERSION_STRING,
			   "OK",NULL,0,0
			   );
		set_palette(p);
		return NULL;
	}

	*screensaver_name = entry->screensaver_name;
	COMMSTRUCT *comm = new COMMSTRUCT;
 
	comm->putpixel = putpixel;
	comm->getpixel = getpixel;
	comm->circle = circle;
	comm->circlefill = circlefill;
	comm->rect = rect;
	comm->rectfill = rectfill;
	comm->makecol = makecol;
	comm->create_bitmap = create_bitmap;
	comm->destroy_bitmap = destroy_bitmap;
	comm->clear_to_color = clear_to_color;
	comm->blit = blit;
	comm->stretch_blit = stretch_blit;
	comm->returnchecker = retcheck;
	comm->random = random;    
	comm->screen_w = SCREEN_W;  
	comm->screen_h = SCREEN_H;
	comm->screen = screen;
	comm->ttrace = ttrace;
	comm->vsync = vsync;
	comm->getr = getr;
	comm->getg = getg;
	comm->getb = getb;
   comm->line = line;
	init = entry->init;
	init(comm);

	screensaver = comm->screensaver;
	delete comm;
	return screensaver;
}   

int deflt()
{

	return 0;
}



