/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *          1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#include <whamgui.h>
#include <bordered.h>

void cleanup_wham()
{
    if (WHAM)
    {
        delete WHAM;
    }
}

void wham_standardinit()
{
    WinSystem::InitialBufferSize = 40;  
    WinSystem::Buffer_Increment = 40;
    WinSystem::Buffered = TRUE;
    WinSystem::BackgroundColor= makecol(0,255,255);
    WinSystem::TheScreen = screen;
    WinSystem::Minimum_Size_x = 16;
    WinSystem::Minimum_Size_y = 16;
    WinSystem::UseBoxes = TRUE;
    WinSystem::ShadowStyle = WHAM_NO_SHADOW;
    WinSystem::ShadowColor = 255;
    WinSystem::ShadowSize  = 4;
    whamgui_black_color = 255;
    whamgui_dark_color = 254;
    whamgui_middle_color = 253;
    whamgui_light_color = 252;
    whamgui_white_color = 251;

    WHAM = new WinSystem();
    atexit(cleanup_wham);
}


int init_allegro()
{
    allegro_init();
    install_keyboard();
    install_timer();
    
   if (set_gfx_mode(GFX_AUTODETECT,640,480,0,0)) exit(1);
//   if (set_gfx_mode(GFX_AUTODETECT,800,600,0,0)) exit(1);
//   if (set_gfx_mode(GFX_AUTODETECT,1024,768,0,0)) exit(1);
//    if (set_gfx_mode(GFX_AUTODETECT,320,200,0,0)) exit(1);
    install_mouse();
    show_mouse(screen);
    set_palette(desktop_palette);
    RGB *c =new RGB;
    //white
    c->r = 63;
    c->g = 63;
    c->b = 63;
    set_color(251,c);
    //lgray
    c->r = 45;
    c->g = 45;
    c->b = 45;
    set_color(252,c);
    //gray
    c->r = 35;
    c->g = 35;
    c->b = 35;
    set_color(253,c);
    //dgray
    c->r = 25;
    c->g = 25;
    c->b = 25;
    set_color(254,c);
    //black
    c->r = 0;
    c->g = 0;
    c->b = 0;
    set_color(255,c);

    return 0;
}


void init()
{
    init_allegro();
    wham_standardinit();
}
