/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#include <stdio.h>
#include <math.h>
#include "main.h"


Window *root = NULL;
GuiContainer *navigator  = NULL;
GuiContainer *the_index = NULL;
//GuiContainer *index_scroller = NULL;
GuiContainer *status = NULL;
char xcoord[255],ycoord[255];

TXfile *the_file = NULL;
DIALOG *toc_dialog = NULL;
int 
    index_size_y, 
    index_y = 0,
    file_pos_x = 0, 
    file_pos_y = 0;

int d_get_index_proc(int msg,DIALOG *d,int c)
{
    int ret = wham_d_3dbutton_proc(msg,d,c);
    if (msg == MSG_CLICK)
    {
        if (d->flags & D_SELECTED)
        {
            the_index->show();
            //index_scroller->show();
        }
        else
        {
            the_index->hide();
            //index_scroller->hide();
        }
    }
    return ret;
}

int d_small_status_proc(int msg,DIALOG *d,int c)
{
    int ret = wham_d_3dbutton_proc(msg,d,c);
    if (msg == MSG_CLICK)
    {
        if (d->flags & D_SELECTED)
        {
            status->resize_viewport(50,16);
            status->move_viewport(0,48);
        }
        else
        {
            status->move_viewport(0,0);
            status->resize_viewport(50,80);
        }
    }
    return ret;
}



DIALOG d_status[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { wham_d_text_proc,     1,   1,  50,  16,   255,  0,       0,  0,       0,    0,    xcoord },
   { wham_d_text_proc,     1,  17,  50,  16,   255,  0,       0,  0,       0,    0,    ycoord },
   { d_get_index_proc,     0,  32,  50,  16,   255,  3,    0, 0,       0,    0,    "Index" },
   { d_small_status_proc,     0,  48,  50,  16,   255,  3,    0,  0, 0 ,    0,    "Small" },
   { wham_d_3dbutton_proc,     0,  64,  50,  16,   255,  3,    0,  D_EXIT, 0 ,    0,    "Quit" },
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL }
};


void display()
{
    clear(root->bmp());
    text_mode(0);
    int attr;
    int col;

    for (int i=0;i<60;i++)
    {
        col = 255;
        attr = the_file->get_attrib(i + file_pos_y);
        if (attr & ATTRIB_KEYWORD)
            col = 12;

        if (attr & ATTRIB_CHAPTER)
            textout_centre(root->bmp(),font,the_file->get_line(i +file_pos_y),320,i*10,9);
        else
            textout(root->bmp(),font,the_file->get_line(i +file_pos_y),-file_pos_x*8,i*10,col);
    }
    root->update();
    sprintf(xcoord,"X:%d",file_pos_x);
    sprintf(ycoord,"Y:%d",file_pos_y);
    int c = 0,obj=0;
    wham_dialog_message(d_status,MSG_DRAW,c,&obj,status);
}


int d_indexbutton_proc(int msg,DIALOG *d,int c)
{
    int ret = wham_d_3dbutton_proc(msg,d,c);
    if (msg == MSG_CLICK)
    {
        file_pos_y = the_file->get_toc_line(d->d1);
        file_pos_x = 0;
        display();
        d->flags &= ~D_SELECTED;
        WHAM_SEND_MESSAGE(d,MSG_DRAW,c);
    }
    return ret;
}




int d_scrollindex_proc(int msg,DIALOG *d,int c)
{
    int ret = wham_d_3dbutton_proc(msg,d,c);
    if (msg == MSG_CLICK)
    {
        for (int i = 0; i<abs(d->d1);i+=10)
        {
            index_y += SGN(d->d1) *10;
            if (index_y<0) index_y = 0;
            if (index_y>index_size_y - 300) index_y = index_size_y - 300;
            the_index->move_viewport(0, index_y);
        }
        d->flags &= ~D_SELECTED;
        WHAM_SEND_MESSAGE(d,MSG_DRAW,c);
    }
    return ret;
}

int d_scrollfile_proc(int msg,DIALOG *d,int c)
{
    int ret = wham_d_3dbutton_proc(msg,d,c);
    if (msg == MSG_CLICK)
    {
        file_pos_x += d->d1;
        file_pos_y += d->d2;
        display();
        d->flags &= ~D_SELECTED;
        WHAM_SEND_MESSAGE(d,MSG_DRAW,c);
    }
    return ret;
}



DIALOG scroll_index[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_scrollindex_proc,     0,   0,  40,  16,   255,  3,    0,  0,       -200,    0,    "up" },
   { d_scrollindex_proc,     0,  16,  40,  16,   255,  3,    0,  0,       200,    0,    "down" },
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL }
};

DIALOG scroll_file[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_scrollfile_proc,     16,   0,  40,  16,   255,  3,    0,  0,       0,  -30,    "up" },
   { d_scrollfile_proc,     16,  16,  40,  16,   255,  3,    0,  0,       0,   30,    "down" },
   { d_scrollfile_proc,     0,   0,  16,  32,   255,  3,    0,  0,      -30,    0,    "<" },
   { d_scrollfile_proc,     56,  0,  16,  32,   255,  3,    0,  0,       30,    0,    ">" },
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL }
};


void setup_toc_dialog()
{
    int nr = the_file->get_number_of_toc_entries();
    toc_dialog = (DIALOG *)malloc(sizeof(DIALOG) * (nr + 1));
    index_size_y = nr * 16;

    for (int i=0;i<nr;i++)
    {
                           /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
        toc_dialog[i].proc = d_indexbutton_proc; 
        toc_dialog[i].x = 0;
        toc_dialog[i].y = i * 16;
        toc_dialog[i].w = 220;
        toc_dialog[i].h = 16;
        toc_dialog[i].fg = 0;
        toc_dialog[i].bg = 0;
        toc_dialog[i].key = 0;
        toc_dialog[i].flags = 0;
        toc_dialog[i].d1 = i;
        toc_dialog[i].d2 = 0;
        toc_dialog[i].dp = strdup(the_file->get_toc_entry(i));
    }
    toc_dialog[nr].proc = NULL;
}



void setup_windows()
{
    ScrollBar *s; 
    root = new Window("root",WHAM->get_TheScreen_size_x(), WHAM->get_TheScreen_size_y(),0,0);
    root->set_lock(TRUE);

    the_index = new GuiContainer(220,index_size_y,50,100,"index1",toc_dialog);
    the_index->resize_viewport(220,300);
    the_index->start();
    s = new ScrollBar(the_index,TYPE_VERTICAL_SCROLLBAR);


    //index_scroller = new GuiContainer(40,32,10,120,"index2",scroll_index);
    //index_scroller->raise();
    //index_scroller->set_lock(TRUE);
    //index_scroller->start();
    //index_scroller->attach_to(the_index,WINDOW_UR_CORNER,WINDOW_UL_CORNER,0,0);
    //the_index->attach_to(index_scroller,WINDOW_UL_CORNER,WINDOW_UR_CORNER,0,0);
    //index_scroller->show();

    navigator = new GuiContainer(72,32,400,300,"navigator",scroll_file);
    navigator->raise_and_lock();
    navigator->start();
    navigator->show();
    navigator->set_lock(TRUE);


    status = new GuiContainer(50,80,400,380,"status",d_status);
    status->raise_and_lock();
    status->start();
    status->show();
    status->set_lock(TRUE);
    status->attach_to(navigator, WINDOW_UR_CORNER,WINDOW_LR_CORNER,-10,0);
    navigator->attach_to(status, WINDOW_LR_CORNER,WINDOW_UR_CORNER,10,0);


    root->show();

}



int main(int argc, char **argv)
{
    if (argc < 2)
        fatal("no input file given");
    init();
    the_file = new TXfile(argv[1]);
    setup_toc_dialog();
    Wham_Secretary.set_key_catching(FALSE);
    setup_windows();
    display();

    if (argc > 2)
    {
        file_pos_y = the_file->get_toc_line(argv[2]);
        file_pos_x = 0;
        if (!file_pos_y)
           alert("Could not find keyword:",argv[2],NULL,"OK",NULL,0,0);
        display();
    }

    while (status->is_running())
    {
        Wham_Secretary.process_mouse();
        if (key[KEY_ESC]) break;
        if (key[KEY_B])
        {
            show_mouse(NULL);
            WHAM->show_all_boxlist_boxes();
            trace("going to defrag");
            WHAM->defrag_all_boxlist_boxes();
            trace("now defragged");
            WHAM->show_all_boxlist_boxes();
            show_mouse(screen);
        }
        if (key[KEY_PGDN])
        {
            file_pos_y += 10;
            display();
        }
        if (key[KEY_PGUP])
        {
            file_pos_y -= 10;
            display();
        }
        if (key[KEY_UP])
        {
            file_pos_y--;
            display();
        }
        if (key[KEY_DOWN])
        {
            file_pos_y++;
            display();
        }
        if (key[KEY_LEFT])
        {
            file_pos_x--;
            display();
        }
        if (key[KEY_RIGHT])
        {
            file_pos_x++;
            display();
        }

        if (key[KEY_HOME])
        {
            file_pos_x = 0;
            display();
        }
        if (key[KEY_END])
        {
            file_pos_x += 10;
            display();
        }
    }

}
