#include <stdio.h>
#include "..\include\secretar.h"
#include "..\include\framewin.h"


int main(int argc, char **argv)
{
    if (argc < 5)
    {
        printf("Usage:\n testwhs <file.whs> <screen_w> <screen_h> <bpp>\n"
               " example\n : testwhs test.whs 320 200 8\n");
        exit(1);
    }
    allegro_init(); // initialise Allegro
    install_timer();     
    install_keyboard(); // install Allegro keyboard handle (to use readkey(), so I don't need getch())



    install_mouse(); 
    set_color_depth(atoi(argv[4]));
    if (set_gfx_mode(GFX_AUTODETECT,atoi(argv[2]),atoi(argv[3]),0,0))  // set graphics mode
    {
        printf("Unable to enter graphics mode:%s",allegro_error);
        exit(1);
    }
    show_mouse(screen);  // turn on mouse cursor
    set_palette(desktop_palette);


    RGB *c = new RGB;
    for (int r=0;r<6;r++)    
    for (int g=0;g<6;g++)
    for (int b=0;b<6;b++)
    {
        c->r = r*10;
        c->g = g*10;
        c->b = b*10;
        set_color(r + 6 * g +36 * b,c);
    }
    delete c;

 // initialise WinSystem
    WinSystem::Buffered = TRUE; 
    WinSystem::BackgroundColor = makecol(0,0,100); 
    WinSystem::ShadowStyle = WHAM_NO_SHADOW; 
    WinSystem::ShadowSize = 10; 
    WinSystem::ShadowColor = 100; 

    FrameWin::Border_Color = makecol(255,0,0);
    FrameWin::Text_Color = makecol(0,0,0);

    FrameWin *the_window = new FrameWin(280,100,20,50,"test");
    clear_to_color(the_window->bmp(),makecol(255,255,255));
    text_mode(1);    

    the_window->background_color = makecol(255,255,255);
    the_window->show();
    the_window->printf("try to load %s\n",argv[1]);
    the_window->update();
    Wham_Secretary.set_key_catching(FALSE);
    if (Wham_Secretary.load_screen_saver(argv[1],3))
    {
        the_window->printf("loading unsuccessful.\n"
                           "try to rebuild %s\n" 
                           "(see readme.txt in whs dir)",
                           argv[1]
                           );
        the_window->update();

    }
    else
    {
        the_window->printf("loading successful\n"
                           "wait 3 seconds to test the\n" 
                           "screensaver.\n\n"
                           "screensaver name:\n%s",Wham_Secretary.get_current_screen_saver_name()
                            );
        the_window->update();
    }


    // wait for a keypress while letting WhamWin deal with the mouse
    while (!keypressed())
    {
        Wham_Secretary.process_mouse();
    }
    delete WHAM;                                        // cleanup wham
    return 0;
}
